<template>
  <div class="list h-full">
    <div class="flex justify-between">
      <div class="text-xl font-semibold">ประเภทย่อย</div>

      <button
        class="text-primary cursor-pointer font-light"
        @click="selectGroup({})"
      >
        รายการทั้งหมด
      </button>
    </div>

    <div class="flex text-grey mt-4">
      <div class="w-[30px] mr-3"></div>

      <div class="flex-1">รายการ</div>

      <div class="w-[100px] text-center">สถานะ</div>

      <div class="w-[60px] text-center">เชิงลึก</div>
    </div>

    <div style="height: calc(100% - 68px)" class="overflow-y-auto px-4 -mx-4">
      <div
        v-for="(light, index) in light_data"
        :key="index"
        class="flex py-4 border-b border-grey border-opacity-50"
      >
        <img
          :src="require('~/assets/images/street-light (1) 1.svg')"
          alt="street-light (1) 1.svg"
          class="mr-3"
        />

        <div class="flex-1">
          <div class="text-xl font-semibold">
            {{ light.name }}
          </div>

          <div class="text-primary mt-1">{{ light.group.name }}</div>

          <div class="flex text-sm items-center">
            <img
              :src="require('~/assets/images/Location.svg')"
              alt="Location.svg"
              class="mr-1"
            />

            {{ light.position.name }}
          </div>
        </div>

        <div class="w-[100px]">
          <div v-if="selected_group.id" class="text-center text-yellow">
            {{ light.status ? "เปิด" : "ปิด" }}
          </div>

          <el-switch
            v-else
            v-model="light.status"
            style="width: fit-content; display: flex"
            class="mx-auto"
            @change="switchLight(light)"
          ></el-switch>

          <div
            class="flex justify-center items-end font-semibold text-primary mt-3"
          >
            <img
              :src="require('~/assets/images/Group 716.svg')"
              alt="Group 716.svg"
              class="mr-2"
            />

            {{ light.hour }} ชม.
          </div>
        </div>

        <div class="w-[60px]">
          <img
            :src="require('~/assets/images/details 1.svg')"
            alt="details 1.svg"
            class="mx-auto cursor-pointer"
            @click="showEditModal(light)"
          />
        </div>
      </div>
    </div>

    <div v-if="show_modal" class="fixed inset-0 z-50">
      <div
        class="absolute bg-black bg-opacity-80 inset-0"
        @click="closeModal"
      ></div>

      <div
        class="rounded-md bg-darkblue p-8 absolute top-2/4 left-2/4 transform -translate-x-2/4 -translate-y-2/4 w-5/6 overflow-auto max-h-[85%]"
      >
        <LightingListModal
          :closeModal="closeModal"
          :editLight="editLight"
          :light_data="light_data"
          :edit_light="edit_light"
        />
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    light_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
    selectGroup: {
      type: Function,
      default: () => {
        return {};
      },
    },
    selected_group: {
      type: Object,
      default: () => {
        return {};
      },
    },
    editLight: {
      type: Function,
      default: () => {
        return {};
      },
    },
    switchLight: {
      type: Function,
      default: () => {
        return {};
      },
    },
  },
  data() {
    return {
      show_modal: false,
      edit_light: {},
    };
  },
  methods: {
    closeModal() {
      this.show_modal = false;
    },
    showEditModal(light) {
      this.show_modal = true;
      this.edit_light = light;
    },
  },
};
</script>

<style lang="scss" scoped></style>
